
class CalcOrdStat:
    def __init__(self, data):
        self.data = data
        
    def CalcQ( self, p ):
        v = 0.0
        pos = 0.5 + p * self.n
        if pos <= 1:
            v = self.data[0]
        elif pos >= self.n:
            v = self.data[self.n - 1]
        else:
            j = int(pos)
            w1 = pos - j
            w2 = 1.0 - w1
            v = w2 * self.data[j - 1] + w1 * self.data[j]
        return v

    def calc(self):
        self.n = len(self.data)
        for i in range(0, self.n - 1):
            k = i
            for j in range(i + 1, self.n):
                if (self.data[j] < self.data[k]):
                    k = j
            if k > i:
                self.data[k], self.data[i] = self.data[i], self.data[k]
    
        print(self.data)

        min = self.data[0]
        max = self.data[self.n - 1]
        Q1 = self.CalcQ(0.25)
        Med = self.CalcQ(0.5)
        Q3 = self.CalcQ(0.75)

        return min, Q1, Med, Q3, max

data = [8, 5, 7, 6]
os = CalcOrdStat(data)
min, Q1, Med, Q3, max = os.calc()
print("\nMin = %f"%min)
print("Q1  = %f"%Q1)
print("Med = %f"%Med)
print("Q3  = %f"%Q3)
print("Max = %f"%max)

